require 'fltk'
require 'irb'

module FLRB
  include FLTK

  class RBInput < MultilineInput
    def initialize(out, *args)
      super(*args)
      @out = out
    end

    def handle(e)
      r = super(e)
      if( e == FLTK::KEYBOARD )
	if( !@ctrl && (FLTK.event_key == FLTK::Control_L) )
	  @ctrl = true
	elsif( @ctrl && (FLTK.event_key == ?j) )
	  @ctrl = false
	  begin
	    @out.value = (Kernel.instance_eval(value)).inspect
	  rescue Exception => e
	    @out.value = e.inspect
	  end
	  value("")
	end
      end
      return r
    end
  end

  class RBOutput < MultilineOutput
  end
end

FLTK::Window.new(400,200){|win|
  FLTK::Tile.new(400,200){|tile|
    $output = FLRB::RBOutput.new(200,0,200,200)
    $input  = FLRB::RBInput.new($output,0,0,200,200)
  }
  win.resizable(win)
  win.show
}
FLTK.focus($input)
FLTK.run
