# capture a resizing operation

require 'fltk'

class ResizableWindow < FLTK::Window
  def initialize(*args)
    super(*args)
    self.begin{
      @out = FLTK::MultilineOutput.new(10,10,180,180)
      @out.value("Resize/Move this window!")
    }
    resizable(self)
  end

  def resize(x, y, w, h)
    if( @out )
      @out.value = "Resize this window.\n"
      @out.value += "before: (#{self.x}, #{self.y}, #{self.w}, #{self.h})\n"
      super(x, y, w, h)
      @out.value += "after: (#{self.x}, #{self.y}, #{self.w}, #{self.h})\n"
    else
      super(x, y, w, h)
    end
  end
end

win = ResizableWindow.new(200,200)
win.show
FLTK.run
