require 'fltk'

class WaveWidget < FLTK::Widget
  include FLTK::Drawable

  SIZEX = 1000
  SIZEY = 400
  def initialize
    size(SIZEX,SIZEY)
  end

  def draw
    if( damage > 0 )
      clear
      SIZEX.times do | i |
	x = i * 2 * 3.1415927 / SIZEX
	y = Math.sin(x)
	color(FLTK::BLACK)
	point(i,y*SIZEY/2+SIZEY/2)
      end
    end
  end
end

class MyWindow < FLTK::DoubleWindow
  def initialize
    super(300, 300, 'Scrolling'){|win|
      FLTK::Pack.new(w,h){|pack|
	title = FLTK::Box.new(80, 20, 'Sine Wave')
	title.box(FLTK::BORDER_BOX)
	FLTK::Scroll.new(w,h-20){|pane|
	  pack.resizable(pane)
	  wave = WaveWidget.new
	}
	win.resizable(pack)
      }
      yield(win)
    }
  end
end

MyWindow.new{|win|
  win.show
}
FLTK.run
