require 'fltk'

class MyBrowser < FLTK::Browser_
  include FLTK::Drawable

  def initialize(x,y,w,h,args)
    super(x,y,w,h)
    @selected_items = {}
    @items = args.collect{|arg| arg.to_s}
  end

  def handle(e)
    case e
    when FLTK::PUSH
      item = find_item(FLTK.event_y)
      bx,by,bw,bh = bbox
      if( item && (FLTK.event_x < bx + bw) )
	select(item,true)
	return true
      end
    end
    return super(e)
  end

  def item_next(obj)
    @items[@items.index(obj) + 1]
  end

  def item_prev(obj)
    idx = @items.index(obj)
    if( idx > 0 )
      @items[idx - 1]
    else
      nil
    end
  end

  def item_first
    @items[0]
  end

  def item_draw(obj, x, y, w, h)
    color(textcolor)
    text_draw(obj, x, y + bbox[1])
  end

  def item_height(obj)
    15
  end

  def item_width(obj)
    text_width(obj)
  end

  def full_height
    p :full_height
    super
  end

  def full_width
    p :full_width
    super
  end

  def item_select(item, s)
    @selected_items[item] = true
  end

  def item_selected(item)
    p @selected_items
    @selected_items[item]
  end
end

items = ["one", "two", "three", "four", "five", "six", "seven", "eight"]

w = FLTK::Window.new(0,0,100,100,"Label")
b = MyBrowser.new(5,5,90,90,items)
b.textcolor = FLTK::RED
w.groupend
GC.start
GC.start

w.show
FLTK.font(FLTK::HELVETICA,14)
FLTK.run
