require 'fltk'

def print_status
  print("$w1 = #{$w1.destroyed?}\n")
  print("$w2 = #{$w2.destroyed?}\n")
  print("$b1 = #{$b1.destroyed?}\n")
  print("$b2 = #{$b2.destroyed?}\n")
  print("$b3 = #{$b3.destroyed?}\n")
  print("\n")
end

class MyWindow < FLTK::Window
  def handle(e)
    case e
    when FLTK::PUSH
      destroy
      print_status
      return true
    end
    return false
  end
end

$w1 = MyWindow.new(100,100)
$w2 = FLTK::Window.new(100,100){|w|
  $b1 = FLTK::Button.new(0,0,50,25,"button1"){ print("button1\n") }
  $b2 = FLTK::Button.new(50,0,50,25,"button2"){ print("button2\n") }
  $b3 = FLTK::Button.new(0,25,50,25,"quit"){ w.destroy; print_status }
}

$w1.show
$w2.show

print_status

GC.start
FLTK.run
GC.start

print_status
