require 'fltk'

class MyWindow < FLTK::Window
  def initialize(*args)
    super(*args)
  end

  def handle(e)
    # can't catch any event.
    return false
  end

  def inspect
    orig = super
    orig.chop!
    orig += " x=#{x},y=#{y},w=#{w},h=#{h} valid?=#{valid?}>"
    return orig
  end
end

$win = MyWindow.new(0,0,300,200, "MyWindow")
$win.show
$win.callback("some data"){|win, data|
  print("the callback is called with the data #{data.inspect}.\n")
  exit
}
$win.groupend

FLTK.add_handler{|e|
  if( e < 5 )
    print("(e < 5) event #{e} is caught.\n")
    true
  else
    false
  end
}

FLTK.add_handler{|e|
  if( e >= 5 )
    print("(e >= 5) event #{e} is caught.\n")
    true
  else
    false
  end
}

GC.start
FLTK.run

