require 'fltk'

def make_image(w, h)
  image = []
  for y in 0 .. (h - 1)
    dy = y.to_f / (h - 1)
    for x in 0 .. (w - 1)
      dx = x.to_f / (w - 1)
      image.push((255 * ((1-dx)*(1-dy))).to_i)
      image.push((255 * ((1-dx)*dy)).to_i)
      image.push((255 * (dx*dy)).to_i)
    end
  end
  return image
end

$width = 75
$height = 75
$image = make_image($width, $height)

FLTK::Window.new(0,0,400,400){|window|
  b = FLTK::Button.new(10,10,380,380)
  if( defined?(FLTK::RGBImage) )
    img = FLTK::RGBImage.new($image,$width,$height)
  else
    img = FLTK::Image.new($image,$width,$height)
  end
  b.image(img)  # fltk-1.1.x
  #img.label(b) # fltk-1.0.x
  window.show
}

FLTK.run
