# This script requires libiconv-1.7 and a ruby extension module for
# iconv. It works well with fltk-1.0.11-utf.
#
# fltk-1.0.11-utf: http://oksid.ch/fltk-utf/
# libiconv-1.7: http://clisp.cons.org/~haible/packages-libiconv.html
# iconv extension: http://www.ruby-lang.org/en/raa-list.rhtml?name=iconv

require 'iconv'
require 'fltk'

label1 = Iconv.iconv('UTF-8', 'EUC-JP', 'λ').join("")
label2 = Iconv.iconv('UTF-8', 'EUC-JP', 'λ').join("")
FLTK.set_font(FLTK::FREE_FONT,
              "a14,a12," +
                "-*-fixed-*-*-*--*-*-*-*-*-*-jisx0201.1976-*," +
                "-*-fixed-*-*-*--*-*-*-*-*-*-jisx0208.1983-*," +
                "-*-fixed-*-*-*--*-*-*-*-*-*-iso10646-1")
w = FLTK::Window.new(100,50){
  b = FLTK::Button.new(0,0,50,20,label1)
  b.labelfont(FLTK::FREE_FONT)
  b = FLTK::Button.new(50,0,50,20,label2)
  b.labelfont(FLTK::FREE_FONT)
}
w.show
FLTK.run
