require 'fltk'
require 'fltk/thread'

class MyWindow < FLTK::Window
  def initialize(*args)
    super(*args)
  end

  def handle(e)
    print("handle(#{e}) was called\n")
  end

  def inspect
    orig = super
    orig.chop!
    orig += " x=#{x},y=#{y},w=#{w},h=#{h} destroyed?=#{destroyed?}>"
    return orig
  end
end

$win = MyWindow.new(0,0,300,200, "MyWindow")
$win.show
$win.cursor(FLTK::CURSOR_NONE)
$win.callback("some data"){|win, data|
  print("the callback is called with the data #{data.inspect}.\n")
  exit
}
$win.groupend
Thread.start{
  while( true )
    sleep 1
    $win.label("YourWindow?")
    $win.size($win.w + 10, $win.h + 10)
    p $win
    sleep 1
    $win.label("MyWindow?")
    $win.size($win.w + 10, $win.h + 10)
    p $win
  end
}

GC.start
FLTK.run

