# -*- ruby -*-
# $Id: polygon.rb,v 1.2 2002/07/19 15:08:42 ttate Exp $

module Fltk
class Canvas
  class Polygon < CanvasItem
    def initialize(canvas, vs, lstyle = nil, lwidth = nil,
		   color1 = nil, color2 = nil, fill = nil)
      super(canvas, lstyle, lwidth, color1, color2, fill)
      @vertexes = vs
    end

    def move(x1, y1, x2, y2)
      dx = x2 - x1
      dy = y2 - y1
      @vertexes.collect!{|vx,vy| [vx + dx, vy + dy]}
    end

    def under_mouse?(x, y)
      x0, y0 = @vertexes[0]
      i, j = 1, 2
      while( j < @vertexes.size )
	x1, y1 = @vertexes[i]
	x2, y2 = @vertexes[j]
	d0 = Math.sqrt( ((x-x0)**2) + ((y-y0)**2) )
	d1 = Math.sqrt( ((x-x1)**2) + ((y-y1)**2) )
	d2 = Math.sqrt( ((x-x2)**2) + ((y-y2)**2) )
	l01 = Math.sqrt( ((x0-x1)**2) + ((y0-y1)**2) )
	l12 = Math.sqrt( ((x1-x2)**2) + ((y1-y2)**2) )
	l20 = Math.sqrt( ((x2-x0)**2) + ((y2-y0)**2) )
	if( l01 < d0 + d1 && d0 + d1 < l12 + l20 &&
	    l12 < d1 + d2 && d1 + d2 < l20 + l01 &&
	    l20 < d2 + d0 && d2 + d0 < l01 + l12 )
	  return true
	end
	i, j = i+1, j+1
      end
      return false
    end

    def draw
      set_style{
	if( @fill )
	  @canvas.begin_polygon{
	    @vertexes.each{|x,y|
	      @canvas.vertex(*grid(x,y))
	    }
	  }
	else
	  @canvas.begin_loop{
	    @vertexes.each{|x,y|
	      @canvas.vertex(*grid(x,y))
	    }
	  }
	end
      }
    end
  end

  class CPolygon < Polygon
    def move(x1, y1, x2, y2)
      dx = x2 - x1
      dy = y2 - y1
      @vertexes.each{|v|
	vx,vy = v
	r = (x1 - vx) ** 2 + (y1 - vy) ** 2
	if( r <= @range ** 2 )
	  v[0] += dx
	  v[1] += dy
	  return
	end
      }
      @vertexes.collect!{|vx,vy| [vx + dx, vy + dy]}
    end
  end
end
end
